diff -ruN freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c
--- freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c	Mon Feb 26 19:51:01 2001
+++ freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c	Wed May 16 10:57:20 2001
@@ -1387,29 +1465,37 @@
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_getspi_parse: "
 			    "failed to add the larval SA with error=%d.\n",
 			    error);
-		goto errlab;
+		SENDERR(-error);
 	}
+	extr->tdb = NULL;
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_getspi_parse: successful for SA: %s\n", sa);
+		    "klips_debug:pfkey_getspi_parse: "
+		    "successful for SA: %s\n",
+		    sa_len ? sa : " (error)");
 	
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_getspi_parse: "
 			    "failed to build the getspi reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	for(pfkey_socketsp = pfkey_open_sockets;
 	    pfkey_socketsp;
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_getspi_parse: "
-				    "sending up getspi reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up getspi reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_getspi_parse: "
-			    "sending up getspi reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up getspi reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 
  errlab:
@@ -1426,6 +1512,7 @@
 	int error = 0;
 	struct tdb* tdbq;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 	struct sadb_ext *extensions_reply[SADB_EXT_MAX+1];
 	struct sadb_msg *pfkey_reply = NULL;
 	struct socket_list *pfkey_socketsp;
@@ -1447,11 +1534,12 @@
 
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_update_parse: error, extr or extr->tdb pointer NULL\n");
+			    "klips_debug:pfkey_update_parse: "
+			    "error, extr or extr->tdb pointer NULL\n");
 		SENDERR(EINVAL);
 	}
 
-	satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
 
 	spin_lock_bh(&tdb_lock);
 
@@ -1459,8 +1547,9 @@
 	if (!tdbq) {
 		spin_unlock_bh(&tdb_lock);
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug: pfkey_update_parse: reserved Tunnel Descriptor Block\n"
-			    "klips_debug:            for SA: %s not found.  Call SADB_GETSPI first or call SADB_ADD instead.\n", sa);
+			    "klips_debug:pfkey_update_parse: "
+			    "reserved Tunnel Descriptor Block for SA: %s not found.  Call SADB_GETSPI first or call SADB_ADD instead.\n",
+			    sa_len ? sa : " (error)");
 		SENDERR(EEXIST);
 	}
 
@@ -1469,9 +1558,10 @@
 	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_update_parse: existing Tunnel Descriptor Block found (this\n"
-		    "klips_debug:                is good) for SA: %s, %s-bound, updating.\n",
-		    sa, extr->tdb->tdb_flags & EMT_INBOUND ? "in" : "out");
+		    "klips_debug:pfkey_update_parse: "
+		    "existing Tunnel Descriptor Block found (this is good) for SA: %s, %s-bound, updating.\n",
+		    sa_len ? sa : " (error)",
+		    extr->tdb->tdb_flags & EMT_INBOUND ? "in" : "out");
 	
 	/* XXX extr->tdb->tdb_rcvif = &(enc_softc[em->em_if].enc_if);*/
 	extr->tdb->tdb_rcvif = NULL;
@@ -1479,8 +1569,8 @@
 		spin_unlock_bh(&tdb_lock);
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_update_parse: "
-			    "not successful for SA: %s, deleting.\n", sa);
-		ipsec_tdbwipe(extr->tdb);
+			    "not successful for SA: %s, deleting.\n",
+			    sa_len ? sa : " (error)");
 		SENDERR(-error);
 	}
 
@@ -1490,12 +1580,13 @@
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_update_parse: "
 			    "error=%d, trouble deleting intermediate tdb for SA=%s.\n",
-			    error, sa);
+			    error,
+			    sa_len ? sa : " (error)");
 		SENDERR(-error);
 	}
 
 	spin_unlock_bh(&tdb_lock);
-
+	
 	if(!(pfkey_safe_build(error = pfkey_msg_hdr_build(&extensions_reply[0],
 							  SADB_UPDATE,
 							  satype,
@@ -1587,36 +1678,45 @@
 		)) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_update_parse: "
 			    "failed to build the update reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 		
 	if((error = puttdb(extr->tdb))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_update_parse: "
-			    "failed to add the mature SA with error=%d.\n",
+			    "failed to update the mature SA=%s with error=%d.\n",
+			    sa_len ? sa : " (error)",
 			    error);
-		goto errlab;
+		SENDERR(-error);
 	}
+	extr->tdb = NULL;
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_update_parse: successful for SA: %s\n", sa);
+		    "klips_debug:pfkey_update_parse: "
+		    "successful for SA: %s\n",
+		    sa_len ? sa : " (error)");
 	
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_update_parse: "
 			    "failed to build the update reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	for(pfkey_socketsp = pfkey_open_sockets;
 	    pfkey_socketsp;
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_update_parse: "
-				    "sending up update reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up update reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_update_parse: "
-			    "sending up update reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up update reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -1633,13 +1733,14 @@
 	int error = 0;
 	struct tdb* tdbq;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 	struct sadb_ext *extensions_reply[SADB_EXT_MAX+1];
 	struct sadb_msg *pfkey_reply = NULL;
 	struct socket_list *pfkey_socketsp;
 	uint8_t satype = ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype;
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_add_parse: parsing add message\n");
+		    "klips_debug:pfkey_add_parse: .\n");
 
 	pfkey_extensions_init(extensions_reply);
 
@@ -1654,17 +1755,19 @@
 
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_add_parse: extr or extr->tdb pointer NULL\n");
+			    "klips_debug:pfkey_add_parse: "
+			    "extr or extr->tdb pointer NULL\n");
 		SENDERR(EINVAL);
 	}
 
-	satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
 
 	tdbq = gettdb(&(extr->tdb->tdb_said));
 	if (tdbq) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_add_parse: found an old Tunnel Descriptor Block\n"
-			    "klips_debug:                for SA: %s, delete it first.\n", sa);
+			    "klips_debug:pfkey_add_parse: "
+			    "found an old Tunnel Descriptor Block for SA%s, delete it first.\n",
+			    sa_len ? sa : " (error)");
 		SENDERR(EEXIST);
 	}
 
@@ -1673,18 +1776,20 @@
 	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_add_parse: existing Tunnel Descriptor Block not found (this\n"
-		    "klips_debug:                is good) for SA: %s, %s-bound, allocating.\n",
-		    sa, extr->tdb->tdb_flags & EMT_INBOUND ? "in" : "out");
+		    "klips_debug:pfkey_add_parse: "
+		    "existing Tunnel Descriptor Block not found (this is good) for SA%s, %s-bound, allocating.\n",
+		    sa_len ? sa : " (error)",
+		    extr->tdb->tdb_flags & EMT_INBOUND ? "in" : "out");
 	
 	/* XXX extr->tdb->tdb_rcvif = &(enc_softc[em->em_if].enc_if);*/
 	extr->tdb->tdb_rcvif = NULL;
 	
 	if ((error = pfkey_tdb_init(extr->tdb, extensions))) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_add_parse: not successful for SA: %s, deleting.\n", sa);
-		ipsec_tdbwipe(extr->tdb);
-		goto errlab;
+			    "klips_debug:pfkey_add_parse: "
+			    "not successful for SA: %s, deleting.\n",
+			    sa_len ? sa : " (error)");
+		SENDERR(-error);
 	}
 
 	extr->tdb->tdb_lifetime_addtime_c = jiffies / HZ;
@@ -1772,36 +1877,44 @@
 		)) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_add_parse: "
 			    "failed to build the add reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 		
 	if((error = puttdb(extr->tdb))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_add_parse: "
 			    "failed to add the mature SA with error=%d.\n",
 			    error);
-		goto errlab;
+		SENDERR(-error);
 	}
+	extr->tdb = NULL;
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_add_parse: successful for SA: %s\n", sa);
+		    "klips_debug:pfkey_add_parse: "
+		    "successful for SA: %s\n",
+		    sa_len ? sa : " (error)");
 	
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_add_parse: "
 			    "failed to build the add reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	for(pfkey_socketsp = pfkey_open_sockets;
 	    pfkey_socketsp;
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_add_parse: "
-				    "sending up add reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up add reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_add_parse: "
-			    "sending up add reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up add reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -1817,6 +1930,7 @@
 {
 	struct tdb *tdbp;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 	int error = 0;
 	struct sadb_ext *extensions_reply[SADB_EXT_MAX+1];
 	struct sadb_msg *pfkey_reply = NULL;
@@ -1835,7 +1949,7 @@
 		SENDERR(EINVAL);
 	}
 
-	satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
 
 	spin_lock_bh(&tdb_lock);
 
@@ -1845,7 +1959,7 @@
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_delete_parse: "
 			    "Tunnel Descriptor Block not found for SA:%s, could not delete.\n",
-			    sa);
+			    sa_len ? sa : " (error)");
 		SENDERR(ESRCH);
 	}
 
@@ -1854,7 +1968,8 @@
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_delete_parse: "
 			    "error=%d returned trying to delete Tunnel Descriptor Block for SA:%s.\n",
-			    error, sa);
+			    error,
+			    sa_len ? sa : " (error)");
 		SENDERR(-error);
 	}
 	spin_unlock_bh(&tdb_lock);
@@ -1890,31 +2005,34 @@
 		)) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_delete_parse: "
 			    "failed to build the delete reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_delete_parse: "
 			    "failed to build the delete reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	for(pfkey_socketsp = pfkey_open_sockets;
 	    pfkey_socketsp;
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_delete_parse: "
-				    "sending up delete reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up delete reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_delete_parse: "
-			    "sending up delete reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up delete reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
-	ipsec_tdbwipe(extr->tdb);
-
 	if (pfkey_reply) {
 		pfkey_msg_free(&pfkey_reply);
 	}
@@ -1928,6 +2046,7 @@
 	int error = 0;
 	struct tdb *tdbp;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 	struct sadb_ext *extensions_reply[SADB_EXT_MAX+1];
 	struct sadb_msg *pfkey_reply = NULL;
 
@@ -1943,7 +2062,7 @@
 		SENDERR(EINVAL);
 	}
 
-	satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
 
 	spin_lock_bh(&tdb_lock);
 
@@ -1952,7 +2071,7 @@
 		spin_unlock_bh(&tdb_lock);
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_get_parse: "
 			    "Tunnel Descriptor Block not found for SA=%s, could not get.\n",
-			    sa);
+			    sa_len ? sa : " (error)");
 		SENDERR(ESRCH);
 	}
 	
@@ -2079,7 +2198,7 @@
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_get_parse: "
 			    "failed to build the get reply message extensions\n");
 		spin_unlock_bh(&tdb_lock);
-		goto errlab;
+		SENDERR(-error);
 	}
 		
 	spin_unlock_bh(&tdb_lock);
@@ -2087,13 +2206,13 @@
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_get_parse: "
 			    "failed to build the get reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	if((error = pfkey_upmsg(sk->socket, pfkey_reply))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_get_parse: "
 			    "failed to send the get reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_get_parse: "
@@ -2117,7 +2236,7 @@
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_acquire_parse: .\n");
 
-	/* I don't know if we want an upper bound, since userspace may
+	/* XXX I don't know if we want an upper bound, since userspace may
 	   want to register itself for an satype > SADB_SATYPE_MAX. */
 	if((satype == 0) || (satype > SADB_SATYPE_MAX)) {
 		KLIPS_PRINT(debug_pfkey,
@@ -2129,8 +2248,9 @@
 
 	if(!(pfkey_registered_sockets[satype])) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire_parse: "
-			    "no sockets registered for SAtype=%d.\n",
-			    satype);
+			    "no sockets registered for SAtype=%d(%s).\n",
+			    satype,
+			    satype2name(satype));
 		SENDERR(EPROTONOSUPPORT);
 	}
 
@@ -2140,13 +2260,18 @@
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp,
 					((struct sadb_msg*)extensions[SADB_EXT_RESERVED])))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire_parse: "
-				    "sending up acquire reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up acquire reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire_parse: "
-			    "sending up acquire reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up acquire reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -2170,7 +2295,7 @@
 
 	pfkey_extensions_init(extensions_reply);
 
-	/* I don't know if we want an upper bound, since userspace may
+	/* XXX I don't know if we want an upper bound, since userspace may
 	   want to register itself for an satype > SADB_SATYPE_MAX. */
 	if((satype == 0) || (satype > SADB_SATYPE_MAX)) {
 		KLIPS_PRINT(debug_pfkey,
@@ -2184,8 +2309,10 @@
 				 &(pfkey_registered_sockets[satype]))) {
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_register_parse: "
-			    "SATYPE=%02d successfully registered by KMd on pid=%d.\n",
-			    satype, key_pid(sk));
+			    "SATYPE=%02d(%s) successfully registered by KMd (pid=%d).\n",
+			    satype,
+			    satype2name(satype),
+			    key_pid(sk));
 	};
 	
 	/* send up register msg with supported SATYPE algos */
@@ -2218,7 +2345,8 @@
 	if(alg_num_a) {
 		if((alg_a = kmalloc(alg_num_a * sizeof(struct sadb_alg), GFP_ATOMIC) ) == NULL) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_register_parse: auth alg memory allocation error\n");
+				    "klips_debug:pfkey_register_parse: "
+				    "auth alg memory allocation error\n");
 			SENDERR(ENOMEM);
 		}
 		alg_ap = alg_a;
@@ -2227,7 +2355,8 @@
 	if(alg_num_e) {
 		if((alg_e = kmalloc(alg_num_e * sizeof(struct sadb_alg), GFP_ATOMIC) ) == NULL) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_register_parse: enc alg memory allocation error\n");
+				    "klips_debug:pfkey_register_parse: "
+				    "enc alg memory allocation error\n");
 			SENDERR(ENOMEM);
 		}
 		alg_ep = alg_e;
@@ -2265,8 +2394,9 @@
 		}
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_register_parse: "
-			    "found satype=%d exttype=%d id=%d ivlen=%d minbits=%d maxbits=%d.\n",
+			    "found satype=%d(%s) exttype=%d id=%d ivlen=%d minbits=%d maxbits=%d.\n",
 			    satype,
+			    satype2name(satype),
 			    pfkey_supported_listp->supportedp->supported_alg_exttype,
 			    pfkey_supported_listp->supportedp->supported_alg_id,
 			    pfkey_supported_listp->supportedp->supported_alg_ivlen,
@@ -2294,26 +2424,31 @@
 					  extensions_reply) : 1))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_register_parse: "
 			    "failed to build the register message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_register_parse: "
 			    "failed to build the register message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	for(pfkey_socketsp = pfkey_registered_sockets[satype];
 	    pfkey_socketsp;
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_register_parse: "
-				    "sending up register reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up register reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_register_parse: "
-			    "sending up register reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up register reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -2343,13 +2478,18 @@
 			if((error = pfkey_upmsg(pfkey_socketsp->socketp,
 						((struct sadb_msg*)extensions[SADB_EXT_RESERVED])))) {
 				KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire_parse: "
-					    "sending up expire reply message for satype=%d to socket=%p failed with error=%d.\n",
-					    satype, pfkey_socketsp->socketp, error);
-				goto errlab;
+					    "sending up expire reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+					    satype,
+					    satype2name(satype),
+					    pfkey_socketsp->socketp,
+					    error);
+				SENDERR(-error);
 			}
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire_parse: "
-				    "sending up expire reply message for satype=%d to socket=%p succeeded.\n",
-				    satype, pfkey_socketsp->socketp);
+				    "sending up expire reply message for satype=%d(%s) to socket=%p succeeded.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp);
 		}
 	}
 
@@ -2363,14 +2503,24 @@
 	int error = 0;
 	struct socket_list *pfkey_socketsp;
 	uint8_t satype = ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype;
+	uint8_t proto = 0;
 
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_flush_parse: "
 		    "flushing type %d SAs\n",
 		    satype);
 
-	if ((error = ipsec_tdbcleanup(satype)))
+	if(satype && !(proto = satype2proto(satype))) {
+		KLIPS_PRINT(debug_pfkey,
+			    "klips_debug:pfkey_flush_parse: "
+			    "satype %d lookup failed.\n", 
+			    ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype);
+		SENDERR(EINVAL);
+	}
+
+	if ((error = ipsec_tdbcleanup(proto))) {
 		SENDERR(-error);
+	}
 
 	if(pfkey_open_sockets) {
 		for(pfkey_socketsp = pfkey_open_sockets;
@@ -2379,15 +2529,18 @@
 			if((error = pfkey_upmsg(pfkey_socketsp->socketp,
 						((struct sadb_msg*)extensions[SADB_EXT_RESERVED])))) {
 				KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_flush_parse: "
-					    "sending up flush reply message for satype=%d to socket=%p failed with error=%d.\n",
+					    "sending up flush reply message for satype=%d(%s) (proto=%d) to socket=%p failed with error=%d.\n",
 					    satype,
+					    satype2name(satype),
+					    proto,
 					    pfkey_socketsp->socketp,
 					    error);
-				goto errlab;
+				SENDERR(-error);
 			}
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_flush_parse: "
-				    "sending up flush reply message for satype=%d to socket=%p succeeded.\n",
+				    "sending up flush reply message for satype=%d(%s) to socket=%p succeeded.\n",
 				    satype,
+				    satype2name(satype),
 				    pfkey_socketsp->socketp);
 		}
 	}
@@ -2444,6 +2597,7 @@
 	struct socket_list *pfkey_socketsp;
 	uint8_t satype = ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype;
 	char sa1[SATOA_BUF], sa2[SATOA_BUF];
+	size_t sa_len1, sa_len2 = 0;
 	int error = 0;
 
 	KLIPS_PRINT(debug_pfkey,
@@ -2451,33 +2605,34 @@
 
 	pfkey_extensions_init(extensions_reply);
 
-	spin_lock_bh(&tdb_lock);
-
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_x_grpsa_parse: "
 			    "extr or extr->tdb is NULL, fatal.\n");
-		spin_unlock_bh(&tdb_lock);
 		SENDERR(EINVAL);
 	}
 
-	satoa(extr->tdb->tdb_said, 0, sa1, SATOA_BUF);
+	sa_len1 = satoa(extr->tdb->tdb_said, 0, sa1, SATOA_BUF);
 	if(extr->tdb2) {
-		satoa(extr->tdb2->tdb_said, 0, sa2, SATOA_BUF);
+		sa_len2 = satoa(extr->tdb2->tdb_said, 0, sa2, SATOA_BUF);
 	}
 
+	spin_lock_bh(&tdb_lock);
+
 	if(!(tdb1p = gettdb(&(extr->tdb->tdb_said)))) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug: pfkey_x_grpsa_parse: reserved Tunnel Descriptor Block\n"
-			    "klips_debug:            for SA: %s not found.  Call SADB_ADD/UPDATE first.\n", sa1);
+			    "klips_debug:pfkey_x_grpsa_parse: "
+			    "reserved Tunnel Descriptor Block for SA: %s not found.  Call SADB_ADD/UPDATE first.\n",
+			    sa_len1 ? sa1 : " (error)");
 		spin_unlock_bh(&tdb_lock);
 		SENDERR(EEXIST);
 	}
 	if(extr->tdb2) { /* GRPSA */
 		if(!(tdb2p = gettdb(&(extr->tdb2->tdb_said)))) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug: pfkey_x_grpsa_parse: reserved Tunnel Descriptor Block\n"
-				    "klips_debug:            for SA: %s not found.  Call SADB_ADD/UPDATE first.\n", sa2);
+				    "klips_debug:pfkey_x_grpsa_parse: "
+				    "reserved Tunnel Descriptor Block for SA: %s not found.  Call SADB_ADD/UPDATE first.\n",
+				    sa_len2 ? sa2 : " (error)");
 			spin_unlock_bh(&tdb_lock);
 			SENDERR(EEXIST);
 		}
@@ -2485,15 +2640,17 @@
 		/* Is either one already linked? */
 		if(tdb1p->tdb_onext) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug: pfkey_x_grpsa_parse: Tunnel Descriptor Block\n"
-				    "klips_debug:                for SA: %s is already linked.\n", sa1);
+				    "klips_debug:pfkey_x_grpsa_parse: "
+				    "Tunnel Descriptor Block for SA: %s is already linked.\n",
+				    sa_len1 ? sa1 : " (error)");
 			spin_unlock_bh(&tdb_lock);
 			SENDERR(EEXIST);
 		}
 		if(tdb2p->tdb_inext) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug: pfkey_x_grpsa_parse: Tunnel Descriptor Block\n"
-				    "klips_debug:                for SA: %s is already linked.\n", sa2);
+				    "klips_debug:pfkey_x_grpsa_parse: "
+				    "Tunnel Descriptor Block for SA: %s is already linked.\n",
+				    sa_len2 ? sa2 : " (error)");
 			spin_unlock_bh(&tdb_lock);
 			SENDERR(EEXIST);
 		}
@@ -2527,7 +2684,7 @@
 
 	if(!(pfkey_safe_build(error = pfkey_msg_hdr_build(&extensions_reply[0],
 							  SADB_X_GRPSA,
-							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype,
+							  satype,
 							  0,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_seq,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_pid),
@@ -2547,34 +2704,36 @@
 							     0,
 							     extr->tdb->tdb_addr_d),
 				 extensions_reply)
-	     && pfkey_safe_build(error = pfkey_x_satype_build(&extensions_reply[SADB_X_EXT_SATYPE2],
-							      proto2satype(extr->tdb2->tdb_said.proto)),
-				 extensions_reply)
-	     && pfkey_safe_build(error = pfkey_sa_build(&extensions_reply[SADB_X_EXT_SA2],
-							SADB_X_EXT_SA2,
-							extr->tdb2->tdb_said.spi,
-							extr->tdb2->tdb_replaywin,
-							extr->tdb2->tdb_state,
-							extr->tdb2->tdb_authalg,
-							extr->tdb2->tdb_encalg,
-							extr->tdb2->tdb_flags),
-				 extensions_reply)
-	     && pfkey_safe_build(error = pfkey_address_build(&extensions_reply[SADB_X_EXT_ADDRESS_DST2],
-							     SADB_X_EXT_ADDRESS_DST2,
-							     0, /*extr->tdb->tdb_said.proto,*/
-							     0,
-							     extr->tdb2->tdb_addr_d),
-				 extensions_reply)
+	     && (extr->tdb2
+		 ? (pfkey_safe_build(error = pfkey_x_satype_build(&extensions_reply[SADB_X_EXT_SATYPE2],
+								  ((struct sadb_x_satype*)extensions[SADB_X_EXT_SATYPE2])->sadb_x_satype_satype
+								  /* proto2satype(extr->tdb2->tdb_said.proto) */),
+								  extensions_reply)
+				     && pfkey_safe_build(error = pfkey_sa_build(&extensions_reply[SADB_X_EXT_SA2],
+										SADB_X_EXT_SA2,
+										extr->tdb2->tdb_said.spi,
+										extr->tdb2->tdb_replaywin,
+										extr->tdb2->tdb_state,
+										extr->tdb2->tdb_authalg,
+										extr->tdb2->tdb_encalg,
+										extr->tdb2->tdb_flags),
+							 extensions_reply)
+				     && pfkey_safe_build(error = pfkey_address_build(&extensions_reply[SADB_X_EXT_ADDRESS_DST2],
+										     SADB_X_EXT_ADDRESS_DST2,
+										     0, /*extr->tdb->tdb_said.proto,*/
+										     0,
+										     extr->tdb2->tdb_addr_d),
+							 extensions_reply) ) : 1 )
 		     )) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_grpsa_parse: "
 			    "failed to build the x_grpsa reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
-
+	   
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_grpsa_parse: "
 			    "failed to build the x_grpsa reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	for(pfkey_socketsp = pfkey_open_sockets;
@@ -2582,24 +2741,28 @@
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_grpsa_parse: "
-				    "sending up x_grpsa reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up x_grpsa reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_grpsa_parse: "
-			    "sending up x_grpsa reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up x_grpsa reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
 	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_grpsa_parse: "
 		    "succeeded in sending x_grpsa reply message.\n");
 	
  errlab:
-	ipsec_tdbwipe(extr->tdb);
-	if(extr->tdb2) {
-		ipsec_tdbwipe(extr->tdb2);
+	if (pfkey_reply) {
+		pfkey_msg_free(&pfkey_reply);
 	}
-
+	pfkey_extensions_free(extensions_reply);
 	return error;
 }
 
@@ -2686,7 +2849,7 @@
 
 	if(!(pfkey_safe_build(error = pfkey_msg_hdr_build(&extensions_reply[0],
 							  SADB_X_ADDFLOW,
-							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype,
+							  satype,
 							  0,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_seq,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_pid),
@@ -2741,13 +2904,13 @@
 		)) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_addflow_parse: "
 			    "failed to build the x_addflow reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 		
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_addflow_parse: "
 			    "failed to build the x_addflow reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	for(pfkey_socketsp = pfkey_open_sockets;
@@ -2755,22 +2918,30 @@
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_addflow_parse: "
-				    "sending up x_addflow reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up x_addflow reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_addflow_parse: "
-			    "sending up x_addflow reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up x_addflow reply message for satype=%d(%s) (proto=%d) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    extr->tdb->tdb_said.proto,
+			    pfkey_socketsp->socketp);
 	}
 	
-	ipsec_tdbwipe(extr->tdb);
-
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_x_addflow_parse: "
 		    "extr->tdb cleaned up and freed.\n");
 
  errlab:
+	if (pfkey_reply) {
+		pfkey_msg_free(&pfkey_reply);
+	}
+	pfkey_extensions_free(extensions_reply);
 	return error;
 }
 
@@ -2853,7 +3024,7 @@
 	
 	if(!(pfkey_safe_build(error = pfkey_msg_hdr_build(&extensions_reply[0],
 							  SADB_X_DELFLOW,
-							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype,
+							  satype,
 							  0,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_seq,
 							  ((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_pid),
